#include <QApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>
#include "bridge.h"
#include "keyboard.h"
#include "../common/sources/Map.h"
#include "player.h"
#include "walls.h"

QQmlContext     *ctxt;

int main(int argc, char *argv[])
{
    QApplication app(argc, argv);

    QQmlApplicationEngine engine;

    walls.readOrnatesDB();
    walls.readWallsDB();

    // register our functions
    ctxt = engine.rootContext();
    ctxt->setContextProperty("bridge", &bridge);

    // register the image provider
    engine.addImageProvider("myimageprovider", new MyImageProvider);

    map.load((char *)"maps/level01.map");
    player.pos.x = 1;
    player.pos.y = 3;
    player.dir = 2;

    // launch the interface
    engine.load(QUrl(QStringLiteral("qrc:/main.qml")));

	// register the event filter for the keyboard
    QApplication::instance()->installEventFilter(&keyboard);

    int retValue = app.exec();

	// unregister the event filter before exiting
    QApplication::instance()->removeEventFilter(&keyboard);

    return retValue;
}

