#ifndef CPLAYER_H
#define CPLAYER_H

#include "../common/sources/system/cmaths.h"
#include "../common/sources/Map.h"

class CPlayer
{
public:
    CPlayer();

    CVec2       getPosFromLocal(CVec2 localPos);
    EWallSide   getWallSide(EWallSide side);

    void        turnLeft();
    void        turnRight();
    void        moveLeft();
    void        moveRight();
    void        moveForward();
    void        moveBackward();

    CVec2   pos;    // position in the map
    uint8_t dir;    // direction: 0=up, 1=left, 2=down, 3=right

private:
    void moveIfPossible(EWallSide side);
};

extern CPlayer  player;

#endif // CPLAYER_H
